diff --git a/lib/hive/web/app_bundle.rb b/lib/hive/web/app_bundle.rb
new file mode 100644
index 00000000..44866144
--- /dev/null
+++ b/lib/hive/web/app_bundle.rb
@@ -0,0 +1,264 @@
+require "digest"
+require "fileutils"
+require "open-uri"
+require "openssl"
+require "securerandom"
+require "timeout"
+require "tmpdir"
+require "hive"
+require "hive/bounded_process"
+require "hive/paths"
+require "hive/web/archive_validator"
+
+module Hive
+  module Web
+    class AppBundle
+      DOWNLOAD_OPEN_TIMEOUT = 10
+      DOWNLOAD_READ_TIMEOUT = 30
+      DOWNLOAD_TOTAL_TIMEOUT = 120
+      PREPARE_TIMEOUT = 600
+
+      attr_reader :version, :url
+
+      def initialize(version: Hive::VERSION, url: nil, sha256: nil,
+                     downloader: nil, runner: nil, cli_root: nil, quiet: false)
+        @version = version
+        @default_url = release_url("hive-web-#{version}.tar.gz")
+        url ||= ENV["HIVE_WEB_BUNDLE_URL"]
+        sha256 ||= ENV["HIVE_WEB_BUNDLE_SHA256"]
+        @url = url || @default_url
+        @sha256 = sha256
+        if url && sha256.to_s.empty?
+          raise Hive::Error, "hive web: a custom bundle URL requires an explicit matching SHA-256"
+        end
+        unless @sha256.nil? || @sha256.match?(/\A[0-9a-f]{64}\z/i)
+          raise Hive::Error, "hive web: bundle SHA-256 must be exactly 64 hexadecimal characters"
+        end
+
+        @downloader = downloader || method(:download)
+        @runner = runner || method(:run)
+        @cli_root = cli_root || installed_cli_root
+        @quiet = quiet
+      end
+
+      def current?
+        active = Hive::Paths.web_app_home
+        File.file?(version_marker) &&
+          File.read(version_marker).strip == version &&
+          File.file?(File.join(active, "Gemfile")) &&
+          File.file?(File.join(active, "Gemfile.lock")) &&
+          File.file?(File.join(active, "config", "application.rb")) &&
+          File.executable?(File.join(active, "bin", "rails"))
+      rescue SystemCallError
+        false
+      end
+
+      def install!
+        return Hive::Paths.web_app_home if current?
+
+        FileUtils.mkdir_p(Hive::Paths.data_home)
+        File.open(lock_path, File::RDWR | File::CREAT, 0o600) do |lock|
+          lock.flock(File::LOCK_EX)
+          return Hive::Paths.web_app_home if current?
+
+          install_locked!
+        end
+      end
+
+      private
+
+      def install_locked!
+        stage_root = Dir.mktmpdir(".hive-web-stage-", Hive::Paths.data_home)
+        archive = File.join(stage_root, "bundle.tar.gz")
+        extracted = File.join(stage_root, "app")
+        @downloader.call(url, archive)
+        expected = @sha256 || trusted_release_sha(stage_root)
+        actual = ::Digest::SHA256.file(archive).hexdigest
+        unless secure_equal?(expected.downcase, actual.downcase)
+          raise Hive::Error,
+                "hive web: checksum mismatch for #{File.basename(archive)} " \
+                "(expected #{expected}, got #{actual})"
+        end
+
+        ArchiveValidator.new(archive).extract_to(extracted)
+        validate_embedded_version!(extracted)
+        prepare!(extracted)
+        activate!(extracted)
+        Hive::Paths.web_app_home
+      rescue Hive::Error
+        raise
+      rescue StandardError => e
+        raise Hive::Error, "hive web: bundle installation failed: #{e.message}"
+      ensure
+        FileUtils.rm_rf(stage_root) if stage_root
+      end
+
+      def trusted_release_sha(stage_root)
+        sums = File.join(stage_root, "SHA256SUMS")
+        @downloader.call(release_url("SHA256SUMS"), sums)
+        verify_signature!(stage_root, sums)
+        asset = "hive-web-#{version}.tar.gz"
+        line = File.readlines(sums, chomp: true).find do |candidate|
+          candidate.match?(/\A[0-9a-f]{64}\s+\*?(?:\.\/)?#{Regexp.escape(asset)}\z/i)
+        end
+        raise Hive::Error, "hive web: release checksums do not contain #{asset}" unless line
+
+        line.split(/\s+/, 2).first
+      end
+
+      def verify_signature!(stage_root, sums)
+        unless executable_on_path?("cosign")
+          raise Hive::Error,
+                "hive web: cosign is required to authenticate the default release bundle; " \
+                "install cosign or use HIVE_WEB_BUNDLE_URL with HIVE_WEB_BUNDLE_SHA256"
+        end
+
+        signature = File.join(stage_root, "SHA256SUMS.sig")
+        certificate = File.join(stage_root, "SHA256SUMS.pem")
+        @downloader.call(release_url("SHA256SUMS.sig"), signature)
+        @downloader.call(release_url("SHA256SUMS.pem"), certificate)
+        identity = "https://github.com/#{Hive::REPO_OWNER}/#{Hive::REPO_NAME}/.github/workflows/release.yml@refs/tags/v#{version}"
+        argv = [
+          "cosign", "verify-blob",
+          "--certificate", certificate,
+          "--signature", signature,
+          "--certificate-identity", identity,
+          "--certificate-oidc-issuer", "https://token.actions.githubusercontent.com",
+          sums
+        ]
+        return if @runner.call({}, argv, chdir: stage_root)
+
+        raise Hive::Error, "hive web: cosign verification failed for release checksums"
+      end
+
+      def validate_embedded_version!(directory)
+        marker = File.join(directory, ".hive-web-version")
+        embedded = File.file?(marker) ? File.read(marker).strip : nil
+        return if embedded == version
+
+        raise Hive::Error,
+              "hive web: bundle version mismatch (expected #{version}, found #{embedded.inspect})"
+      end
+
+      def prepare!(directory)
+        FileUtils.mkdir_p(Hive::Paths.web_gems_home)
+        FileUtils.mkdir_p(Hive::Paths.web_storage_home)
+        seed_matching_default_gems!(directory)
+        env = {
+          "RAILS_ENV" => "production",
+          "BUNDLE_GEMFILE" => File.join(directory, "Gemfile"),
+          "BUNDLE_PATH" => Hive::Paths.web_gems_home,
+          "BUNDLE_WITHOUT" => "development:test",
+          "SECRET_KEY_BASE_DUMMY" => "1",
+          "HIVE_CLI_ROOT" => @cli_root,
+          "HIVE_WEB_STORAGE_DIR" => Hive::Paths.web_storage_home,
+          "HIVEBOX_STORAGE_DIR" => Hive::Paths.web_storage_home
+        }
+        commands = [
+          [ "bundle", "install" ],
+          [ File.join(directory, "bin", "rails"), "assets:precompile" ],
+          [ File.join(directory, "bin", "rails"), "db:prepare" ]
+        ]
+        commands.each do |argv|
+          next if @runner.call(env, argv, chdir: directory)
+
+          raise Hive::Error, "hive web: preparation failed: #{argv.join(' ')}"
+        end
+      end
+
+      # Bundler intentionally refuses to mix a custom BUNDLE_PATH with shared
+      # gems. Re-extracting a matching Ruby default gem can require development
+      # headers that a normal runtime installation does not retain (notably
+      # libyaml for psych). Link exact lockfile matches into the managed bundle
+      # path so the dependency remains version-pinned without recompilation.
+      def seed_matching_default_gems!(directory)
+        lock = File.read(File.join(directory, "Gemfile.lock"))
+        root = File.join(Hive::Paths.web_gems_home, "ruby", Gem.ruby_api_version)
+        gems = File.join(root, "gems")
+        specifications = File.join(root, "specifications")
+        FileUtils.mkdir_p([ gems, specifications ])
+
+        Gem::Specification.select(&:default_gem?).each do |spec|
+          next unless lock.match?(/^\s{4}#{Regexp.escape(spec.name)} \(#{Regexp.escape(spec.version.to_s)}\)/)
+
+          gem_link = File.join(gems, File.basename(spec.full_gem_path))
+          spec_link = File.join(specifications, File.basename(spec.loaded_from))
+          link_default_gem(spec.full_gem_path, gem_link)
+          link_default_gem(spec.loaded_from, spec_link)
+        end
+      end
+
+      def link_default_gem(source, target)
+        FileUtils.rm_f(target) if File.symlink?(target) && !File.exist?(target)
+        FileUtils.ln_s(source, target) unless File.exist?(target) || File.symlink?(target)
+      end
+
+      def activate!(staged)
+        active = Hive::Paths.web_app_home
+        previous = "#{active}.previous-#{Process.pid}-#{SecureRandom.hex(4)}"
+        File.rename(active, previous) if File.exist?(active)
+        begin
+          File.rename(staged, active)
+          FileUtils.rm_rf(previous)
+        rescue StandardError
+          FileUtils.rm_rf(active)
+          File.rename(previous, active) if File.exist?(previous)
+          raise
+        end
+      end
+
+      def installed_cli_root
+        spec = Gem.loaded_specs["hive-cli"]
+        return spec.full_gem_path if spec
+
+        File.expand_path("../../..", __dir__)
+      end
+
+      def release_url(asset)
+        "https://github.com/#{Hive::REPO_OWNER}/#{Hive::REPO_NAME}/releases/download/v#{version}/#{asset}"
+      end
+
+      def download(source, target)
+        Timeout.timeout(DOWNLOAD_TOTAL_TIMEOUT) do
+          URI.open(
+            source,
+            "rb",
+            open_timeout: DOWNLOAD_OPEN_TIMEOUT,
+            read_timeout: DOWNLOAD_READ_TIMEOUT
+          ) do |input|
+            File.open(target, "wb", 0o600) { |output| IO.copy_stream(input, output) }
+          end
+        end
+      end
+
+      def run(env, argv, chdir:)
+        output = @quiet ? File::NULL : $stdout
+        Hive::BoundedProcess.run(
+          env, *argv, chdir: chdir, timeout: PREPARE_TIMEOUT,
+          out: output, err: output
+        )
+      end
+
+      def executable_on_path?(name)
+        ENV["PATH"].to_s.split(File::PATH_SEPARATOR).any? do |directory|
+          path = File.join(directory, name)
+          File.file?(path) && File.executable?(path)
+        end
+      end
+
+      def secure_equal?(left, right)
+        return false unless left.bytesize == right.bytesize
+
+        OpenSSL.fixed_length_secure_compare(left, right)
+      end
+
+      def version_marker
+        File.join(Hive::Paths.web_app_home, ".hive-web-version")
+      end
+
+      def lock_path
+        File.join(Hive::Paths.data_home, ".web-install.lock")
+      end
+    end
+  end
+end
diff --git a/lib/hive/web/archive_validator.rb b/lib/hive/web/archive_validator.rb
new file mode 100644
index 00000000..51791ee5
--- /dev/null
+++ b/lib/hive/web/archive_validator.rb
@@ -0,0 +1,94 @@
+require "fileutils"
+require "pathname"
+require "rubygems/package"
+require "zlib"
+require "hive"
+
+module Hive
+  module Web
+    class ArchiveValidator
+      FILE_TYPES = [ "0", "\0" ].freeze
+      DIRECTORY_TYPE = "5"
+      UNSAFE_MODE_MASK = 0o7022
+
+      def initialize(path)
+        @path = path
+      end
+
+      def extract_to(destination)
+        FileUtils.mkdir_p(destination)
+        each_entry do |entry|
+          relative = safe_path(entry.full_name)
+          validate_type!(entry)
+          validate_mode!(entry)
+          if relative == "."
+            unless entry.header.typeflag == DIRECTORY_TYPE
+              raise Hive::Error, "hive web: archive root entry must be a directory"
+            end
+            next
+          end
+          target = File.join(destination, relative)
+          ensure_inside!(destination, target)
+
+          if entry.header.typeflag == DIRECTORY_TYPE
+            FileUtils.mkdir_p(target)
+            File.chmod(entry.header.mode & 0o777, target)
+          else
+            FileUtils.mkdir_p(File.dirname(target))
+            File.open(target, File::WRONLY | File::CREAT | File::EXCL, entry.header.mode & 0o777) do |io|
+              IO.copy_stream(entry, io)
+            end
+          end
+        end
+        destination
+      rescue Gem::Package::TarInvalidError, Zlib::GzipFile::Error, EOFError => e
+        raise Hive::Error, "hive web: invalid or truncated web archive: #{e.message}"
+      end
+
+      private
+
+      def each_entry
+        Zlib::GzipReader.open(@path) do |gzip|
+          Gem::Package::TarReader.new(gzip) do |tar|
+            tar.each { |entry| yield entry }
+          end
+        end
+      end
+
+      def safe_path(name)
+        raw = name.to_s
+        clean = Pathname.new(raw).cleanpath.to_s
+        if raw.empty? || raw.start_with?("/", "\\") || raw.include?("\0") ||
+           clean == ".." || clean.start_with?("../")
+          raise Hive::Error, "hive web: unsafe archive path #{raw.inspect}"
+        end
+        clean
+      end
+
+      def validate_type!(entry)
+        type = entry.header.typeflag
+        return if FILE_TYPES.include?(type) || type == DIRECTORY_TYPE
+
+        raise Hive::Error,
+              "hive web: archive entry #{entry.full_name.inspect} has unsupported type #{type.inspect} " \
+              "(links, devices, and FIFOs are forbidden)"
+      end
+
+      def validate_mode!(entry)
+        mode = entry.header.mode
+        return if (mode & UNSAFE_MODE_MASK).zero?
+
+        raise Hive::Error,
+              "hive web: archive entry #{entry.full_name.inspect} has unsafe mode #{format('%o', mode)}"
+      end
+
+      def ensure_inside!(root, target)
+        expanded_root = "#{File.expand_path(root)}#{File::SEPARATOR}"
+        expanded_target = File.expand_path(target)
+        return if expanded_target.start_with?(expanded_root)
+
+        raise Hive::Error, "hive web: archive entry escapes the installation directory"
+      end
+    end
+  end
+end
diff --git a/lib/hive/web/daemon_maintenance.rb b/lib/hive/web/daemon_maintenance.rb
new file mode 100644
index 00000000..f33b39fd
--- /dev/null
+++ b/lib/hive/web/daemon_maintenance.rb
@@ -0,0 +1,134 @@
+require "json"
+require "fileutils"
+require "time"
+require "hive"
+require "hive/paths"
+require "hive/commands/service_installer/outcome"
+
+module Hive
+  module Web
+    class DaemonMaintenance
+      ACTIONS = %w[repair restart].freeze
+
+      def initialize(installer:, active_tasks: nil)
+        @installer = installer
+        @active_tasks = active_tasks || method(:current_active_tasks)
+      end
+
+      def call(action)
+        unless ACTIONS.include?(action)
+          raise Hive::InvalidTaskPath,
+                "unknown daemon maintenance action #{action.inspect}"
+        end
+
+        active = Array(@active_tasks.call)
+        if active.any?
+          result = maintenance_result(
+            action,
+            ok: false,
+            message: "refusing daemon #{action}: #{active.length} active agent " \
+                     "#{active.length == 1 ? 'task' : 'tasks'} would be interrupted",
+            refused: true,
+            active_tasks: active
+          )
+          persist(result)
+          return result
+        end
+
+        ok, message = perform(action)
+        result = {
+          "action" => action, "ok" => ok, "message" => message,
+          "completed_at" => Time.now.utc.iso8601,
+          "refused" => false,
+          "active_tasks" => [],
+          "forced_interruptions" => 0
+        }
+        persist(result)
+        result
+      rescue Hive::InvalidTaskPath
+        raise
+      rescue StandardError => e
+        result = {
+          "action" => action.to_s, "ok" => false,
+          "message" => "#{e.class}: #{e.message}", "completed_at" => Time.now.utc.iso8601,
+          "refused" => true,
+          "active_tasks" => [],
+          "forced_interruptions" => 0
+        }
+        persist(result)
+        result
+      end
+
+      def self.last_result
+        path = result_path
+        File.file?(path) ? JSON.parse(File.read(path)) : nil
+      rescue JSON::ParserError, SystemCallError
+        nil
+      end
+
+      def self.result_path
+        File.join(Hive::Paths.state_home, ".daemon-maintenance.json")
+      end
+
+      private
+
+      def perform(action)
+        case action
+        when "repair"
+          outcome = @installer.install!(autostart: true, force: true)
+          [ outcome.success?, "daemon service #{outcome.wire_outcome}; no active agents were interrupted" ]
+        when "restart"
+          stopped = @installer.stop!
+          started = stopped && @installer.start!
+          [
+            !!started,
+            started ? "daemon restarted; no active agents were interrupted" : "daemon restart failed"
+          ]
+        end
+      end
+
+      def maintenance_result(action, ok:, message:, refused:, active_tasks:)
+        {
+          "action" => action,
+          "ok" => ok,
+          "message" => message,
+          "completed_at" => Time.now.utc.iso8601,
+          "refused" => refused,
+          "active_tasks" => active_tasks,
+          "forced_interruptions" => 0
+        }
+      end
+
+      def current_active_tasks
+        require "hive/commands/status"
+        payload = Hive::Commands::Status.new(json: true).json_payload(
+          Hive::Config.registered_projects
+        )
+        payload.fetch("projects").flat_map do |project|
+          project.fetch("tasks", []).filter_map do |task|
+            next unless task["action"] == "agent_running"
+
+            {
+              "project" => project.fetch("name"),
+              "slug" => task.fetch("slug"),
+              "stage" => task.fetch("stage")
+            }
+          end
+        end
+      rescue StandardError => e
+        raise Hive::Error,
+              "cannot verify active agents before daemon maintenance: #{e.class}: #{e.message}"
+      end
+
+      def persist(result)
+        path = self.class.result_path
+        FileUtils.mkdir_p(File.dirname(path))
+        temp = "#{path}.tmp.#{Process.pid}"
+        File.write(temp, JSON.generate(result), mode: "w", perm: 0o600)
+        File.rename(temp, path)
+      ensure
+        FileUtils.rm_f(temp) if temp && File.exist?(temp)
+      end
+    end
+  end
+end
diff --git a/lib/hive/web/environment.rb b/lib/hive/web/environment.rb
new file mode 100644
index 00000000..661bf1a7
--- /dev/null
+++ b/lib/hive/web/environment.rb
@@ -0,0 +1,102 @@
+require "hive"
+require "hive/paths"
+require "hive/web/loopback"
+
+module Hive
+  module Web
+    class Environment
+      attr_reader :bind, :port, :unsafe
+
+      def initialize(config:, bind: nil, port: nil, unsafe: false, env: ENV)
+        @config = config
+        @env = env
+        @bind = first_present(bind, env["HIVE_WEB_BIND"], env["HIVEBOX_BIND"], config["bind"])
+        @port = Integer(first_present(port, env["HIVE_WEB_PORT"], env["HIVEBOX_PORT"], config["port"]))
+        raise Hive::Error, "hive web: port must be between 1 and 65535" unless (1..65_535).cover?(@port)
+
+        @unsafe = unsafe || truthy?(env["HIVE_WEB_UNSAFE"]) || truthy?(env["HIVEBOX_UNSAFE"])
+      rescue ArgumentError, TypeError
+        raise Hive::Error, "hive web: invalid port #{port || env['HIVE_WEB_PORT'] || env['HIVEBOX_PORT']}"
+      end
+
+      def loopback?
+        Loopback.address?(bind)
+      end
+
+      def authentication_configured?
+        !@config.dig("github", "client_id").to_s.strip.empty?
+      end
+
+      def validate_security!
+        return true if loopback? || authentication_configured?
+
+        if unsafe
+          warn "hive web: UNSAFE non-loopback exposure enabled for #{bind}:#{port}; authentication is not configured"
+          return true
+        end
+
+        raise Hive::Error,
+              "hive web: refusing non-loopback bind #{bind.inspect} without a configured GitHub auth flow. " \
+              "Configure web.github.client_id or pass --unsafe to acknowledge unauthenticated exposure."
+      end
+
+      def url
+        host = bind == "::1" ? "[::1]" : bind
+        "http://#{host}:#{port}"
+      end
+
+      def to_h(app_dir:, cli_root:, managed: false)
+        storage = first_present(
+          @env["HIVE_WEB_STORAGE_DIR"],
+          @env["HIVEBOX_STORAGE_DIR"]
+        )
+        storage ||= Hive::Paths.web_storage_home if managed
+        origin = first_present(@env["HIVE_WEB_ORIGIN"], @env["HIVEBOX_ORIGIN"], @config["origin"], url)
+        environment = {
+          "HIVE_WEB_BIND" => bind,
+          "HIVE_WEB_PORT" => port.to_s,
+          "HIVE_WEB_ORIGIN" => origin,
+          "HIVE_WEB_LOCAL_MODE" => loopback? ? "true" : "false",
+          "HIVE_WEB_UNSAFE" => unsafe ? "true" : "false",
+          "HIVE_CONFIG_HOME" => Hive::Paths.config_home,
+          "HIVE_DATA_HOME" => Hive::Paths.data_home,
+          "HIVE_STATE_HOME" => Hive::Paths.state_home,
+          "HIVE_CACHE_HOME" => Hive::Paths.cache_home,
+          "HIVE_CLI_ROOT" => cli_root,
+          "BUNDLE_GEMFILE" => File.join(app_dir, "Gemfile"),
+          # Docker/source compatibility aliases. Canonical names always win
+          # because their values were resolved before these are constructed.
+          "HIVEBOX_ORIGIN" => origin
+        }.merge(xdg_environment)
+        if storage
+          environment["HIVE_WEB_STORAGE_DIR"] = storage
+          environment["HIVEBOX_STORAGE_DIR"] = storage
+        end
+        if managed
+          environment["BUNDLE_PATH"] = Hive::Paths.web_gems_home
+          environment["BUNDLE_WITHOUT"] = "development:test"
+        end
+        environment
+      end
+
+      private
+
+      def xdg_environment
+        {
+          "XDG_CONFIG_HOME" => @env["XDG_CONFIG_HOME"] || File.dirname(Hive::Paths.config_home),
+          "XDG_DATA_HOME" => @env["XDG_DATA_HOME"] || File.dirname(Hive::Paths.data_home),
+          "XDG_STATE_HOME" => @env["XDG_STATE_HOME"] || File.dirname(Hive::Paths.state_home),
+          "XDG_CACHE_HOME" => @env["XDG_CACHE_HOME"] || File.dirname(Hive::Paths.cache_home)
+        }
+      end
+
+      def first_present(*values)
+        values.find { |value| !value.nil? && !value.to_s.empty? }
+      end
+
+      def truthy?(value)
+        %w[1 true yes on].include?(value.to_s.downcase)
+      end
+    end
+  end
+end
diff --git a/lib/hive/web/host_authorization.rb b/lib/hive/web/host_authorization.rb
new file mode 100644
index 00000000..ea3c50e6
--- /dev/null
+++ b/lib/hive/web/host_authorization.rb
@@ -0,0 +1,38 @@
+require "ipaddr"
+require "uri"
+
+module Hive
+  module Web
+    module HostAuthorization
+      module_function
+
+      def allowed_hosts(bind:, origin: nil)
+        [
+          "localhost",
+          IPAddr.new("127.0.0.0/8"),
+          IPAddr.new("::1"),
+          bind_host(bind),
+          origin_host(origin)
+        ].compact.uniq
+      end
+
+      def bind_host(bind)
+        case bind.to_s
+        when "0.0.0.0" then IPAddr.new("0.0.0.0/0")
+        when "::" then IPAddr.new("::/0")
+        else bind
+        end
+      end
+      private_class_method :bind_host
+
+      def origin_host(origin)
+        return if origin.to_s.empty?
+
+        URI(origin).host
+      rescue URI::InvalidURIError
+        nil
+      end
+      private_class_method :origin_host
+    end
+  end
+end
diff --git a/lib/hive/web/loopback.rb b/lib/hive/web/loopback.rb
new file mode 100644
index 00000000..1b145a72
--- /dev/null
+++ b/lib/hive/web/loopback.rb
@@ -0,0 +1,18 @@
+require "ipaddr"
+
+module Hive
+  module Web
+    module Loopback
+      module_function
+
+      def address?(value)
+        text = value.to_s.strip
+        return true if text.casecmp("localhost").zero?
+
+        IPAddr.new(text).loopback?
+      rescue IPAddr::InvalidAddressError
+        false
+      end
+    end
+  end
+end
diff --git a/lib/hive/web/service_status.rb b/lib/hive/web/service_status.rb
new file mode 100644
index 00000000..8274c4f6
--- /dev/null
+++ b/lib/hive/web/service_status.rb
@@ -0,0 +1,72 @@
+require "net/http"
+require "uri"
+require "socket"
+
+module Hive
+  module Web
+    class ServiceStatus
+      def initialize(installer:, url:, http_get: nil, port_in_use: nil)
+        @installer = installer
+        @desired_url = url
+        @http_get = http_get || method(:healthy?)
+        @port_in_use = port_in_use || method(:port_in_use?)
+      end
+
+      def to_h
+        service = @installer.service_state
+        installed = @installer.installed_settings
+        url = installed["url"] || @desired_url
+        manager_available = @installer.service_manager_available?
+        running = @installer.running?
+        health_ready = running && @http_get.call(URI("#{url}/health"))
+        configuration_drift = installed["configuration_drift"] == true
+        ready = health_ready && !configuration_drift
+        failure =
+          if !manager_available then "service_manager_unavailable"
+          elsif !service["service_installed"] then "not_installed"
+          elsif !installed["readable"] then "unit_unreadable"
+          elsif !service["service_enabled"] then "not_enabled"
+          elsif !running && @port_in_use.call(installed["bind"], installed["port"]) then "port_conflict"
+          elsif !running then "process_not_running"
+          elsif !health_ready then "health_failed"
+          elsif configuration_drift then "configuration_drift"
+          end
+        service.merge(
+          "running" => running,
+          "ready" => ready,
+          "url" => url,
+          "desired_url" => @desired_url,
+          "configuration_drift" => configuration_drift,
+          "unsafe" => installed["unsafe"] == true,
+          "failure" => failure,
+          "message" => installed["message"]
+        )
+      rescue StandardError => e
+        {
+          "platform" => nil, "unit_path" => nil, "service_installed" => nil,
+          "service_enabled" => nil, "running" => false, "ready" => false,
+          "url" => @desired_url, "desired_url" => @desired_url,
+          "configuration_drift" => false, "unsafe" => false,
+          "failure" => "probe_failed", "message" => e.message
+        }
+      end
+
+      private
+
+      def healthy?(uri)
+        response = Net::HTTP.start(
+          uri.host, uri.port, open_timeout: 1, read_timeout: 2
+        ) { |http| http.get(uri.request_uri) }
+        response.is_a?(Net::HTTPSuccess)
+      rescue SystemCallError, Timeout::Error, Net::OpenTimeout, Net::ReadTimeout
+        false
+      end
+
+      def port_in_use?(bind, port)
+        Socket.tcp(bind, port, connect_timeout: 0.2) { true }
+      rescue SystemCallError, SocketError, Timeout::Error
+        false
+      end
+    end
+  end
+end
